//+------------------------------------------------------------------+
//|                                                    expert-my.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include<Trade\Trade.mqh>
#include<Trade\PositionInfo.mqh>


static datetime last_time=0;

CTrade  myTrade;
CPositionInfo myPositionInfo;

datetime counted_bar=0;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(!mag(1))
      BUY(1,0.1);

   if(PositionProfit(1)<-10)
      if(!mag(2))
         BUY(2,0.1);

   if(PositionProfit(2)<-10)
      if(!mag(3))
         BUY(3,0.1);

   if(PositionProfit(1)+PositionProfit(2)+PositionProfit(3)>15)
     {
      mPositionClose2(1);
      mPositionClose2(2);
      mPositionClose2(3);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void mPositionClose2(int Magic)
  {
   CTrade trade;
//  MqlTick tick;
   MqlTradeRequest request;
   MqlTradeResult tradeResult;
   MqlTradeCheckResult checkResult;

   for(int i=0;i<PositionsTotal();i++)
     {
      ResetLastError();
      if(PositionGetSymbol(i)==NULL)
        {
         Print("Error #",GetLastError());
         return;
        }
      long POSITION_magik=PositionGetInteger(POSITION_MAGIC);
      long POSITION_ticket=PositionGetInteger(POSITION_TICKET);
      if(POSITION_magik==Magic)
        {
         trade.PositionClose(POSITION_ticket);
         return;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void mPositionClose(int Magic)
  {
//  MqlTick tick;
   MqlTradeRequest request;
   MqlTradeResult tradeResult;
   MqlTradeCheckResult checkResult;

// int mm ;
   ENUM_POSITION_TYPE ttype;

   CTrade mtrade;
   CPositionInfo pos;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;
      pos.Magic();
      ttype=pos.PositionType();

      request.action=TRADE_ACTION_DEAL;
      request.symbol=Symbol();
      request.volume=0.1;// getLot();
                         //  request.deviation    = DEV;
      request.type_filling = ORDER_FILLING_FOK;
      request.type_time    = ORDER_TIME_GTC;
      request.comment      = "";
      request.type=ORDER_TYPE_SELL;                 //   
                                                    //   request.magic        = MAGIC_NUMBER;

      mtrade.PositionClose(pos.Identifier());
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void BUY(int magick,double volume)
  {
   MqlTick last_tick;
   SymbolInfoTick(_Symbol,last_tick);

//---   
   MqlTradeRequest request={0};
   request.action=TRADE_ACTION_DEAL;            //    
   request.magic=magick;                           // ORDER_MAGIC 
                                                   // request.order=2111;                          //   

   request.symbol=_Symbol;                      //  
   request.volume=volume;                          //   0.1  
   request.sl=0;                                // Stop Loss   
   request.tp=0;                                // Take Profit      
//---    
   request.type=ORDER_TYPE_BUY;                 //   
//---     
   request.price=last_tick.ask; //    Ask
                                //    
//---    
   MqlTradeResult result={0};
   if(OrderSend(request,result))
     {
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double PositionProfit(int Magic)
  {
   CTrade trade;
   CPositionInfo pos;
   double prof;
   prof=0;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;
      // if(pos.Profit()>=Profit)
      //  {
      //    trade.PositionClose(pos.Identifier());
      //   }
      prof=pos.Profit();
     }
   return prof;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool mag(int Magic)
  {
   CTrade trade;
   CPositionInfo pos;
   bool m;
   m=false;
   int total=PositionsTotal();
   for(int i=0; i<total; i++)
     {
      if(!pos.SelectByIndex(i))continue;
      if(pos.Magic()!=Magic)continue;
      if(pos.Symbol()!=_Symbol)continue;
      m=true;
     }
   return m;
  }
//+------------------------------------------------------------------+
